# -*- coding: utf-8 -*-
import os

import numpy as np
import matplotlib.pyplot as plt

def f1(x):

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.

def f2(x):

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.

def f3(x):

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.


def mittelpunkt(f, a, b, N):
    """Approximiert das Integral von `f` mit der Mittelpunktregel.

    Input:
           f : Funktion f(x) welche integiert werden soll.
        a, b : untere/obere Grenze des Integrals.
           N : Anzahl Teilintervalle in der zusammengesetzten
               Mittelpunktregel.
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.

def trapezoid(f, a, b, N):
    """Approximiert das Integral von `f` mit der Trapezregel.

    Input:
           f : Funktion f(x) welche integiert werden soll.
        a, b : untere/obere Grenze des Integrals.
           N : Anzahl Teilintervalle in der zusammengesetzten
               Trapezregel.
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.

def simpson(f, a, b, N):
    """Approximiert das Integral von `f` mit der Simpsonregel.

    Input:
           f : Funktion f(x) welche integiert werden soll.
        a, b : untere/obere Grenze des Integrals.
           N : Anzahl Teilintervalle in der zusammengesetzten
               Simpsonregel.
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.

def quadrature_error(quadrature_rule, f, exact):
    """Berechnet den Fehler und die Konvergenzrate.

    Input:
        quadrature_rule : Quadraturformel für welche verwendet werden soll. Die
                          Funktion hat die gleiche Signature wie `simpson` und
                          `trapezoid`.

                      f : Funktion welche integriert werden soll. In der Aufgabe
                          heissen sie `f1` und `f2`.

                  exact : Exakte Referenzlösung des Integrals.

    Output:
                 errors : Fehler der Quadraturformel mit `n_chunks` Teilintervallen.
               n_chunks : Anzahl Teilintervalle.
    """

    # TODO vervollständigen Sie das Template.

    return np.array([1.0, 0.5, 0.25]), np.array([8, 16, 32]) # Bitte ersetzen.

def plot_convergence(n_evals, errors, labels, title):
    """Plottet einen Konvergenzplot in einem neuen Fenster.

    Der Vergleich zwischen Simpson- und Trapezregel soll 'fair' sein. Die
    Simpsonregel wertet `f` fast 2x öfter aus. Plotten Sie deswegen den Fehler
    gegen die Anzahl Funktionsaufrufe.

    Trendlinien der Ordnung 1.5, 2 und 4 werden ebenfalls geplottet.

    Input:
        n_evals : list of array
                  Anzahl Funktionsaufrufe pro Regel pro Auflösung.

         errors : list of array
                  Fehler pro Quadraturregel pro Auflösung.

         labels : list. Text der in der Legende erscheint.
          title : Titel des Plots.
    """

    plt.figure(figsize=(12,8))

    for k, n_eval in enumerate(n_evals):
        plt.loglog(n_eval, errors[k], "-o", label=labels[k])

    # Trendlinien
    plt.loglog(n_evals[0], (1.0*n_evals[0])**-1.5, ":k", label=r"$n^{-1.5}$")
    plt.loglog(n_evals[0], (1.0*n_evals[0])**-2, "-k", label=r"$n^{-2}$")
    plt.loglog(n_evals[0], (1.0*n_evals[0])**-4, "-.k", label=r"$n^{-4}$")

    plt.grid(True)
    plt.xlabel("Anzahl Auswertungen von $f$")
    plt.ylabel("Absoluter Fehler")
    plt.legend(loc="lower left")
    plt.title(title)

def convergence_experiment(f, exact, title, filename):
    errors_mp, n_chunks = quadrature_error(mittelpunkt, f, exact)
    n_mp = n_chunks
    errors_tr, n_chunks = quadrature_error(trapezoid, f, exact)
    n_tr = n_chunks + 1
    errors_si, n_chunks = quadrature_error(simpson, f, exact)
    n_si = 2*n_chunks + 1

    n_evals = [n_mp, n_tr, n_si]
    errors = [errors_mp, errors_tr, errors_si]
    labels = ["Mittelpunkt", "Trapez", "Simpson"]

    plot_convergence(n_evals, errors, labels, title)
    plt.savefig(filename + ".png")
    plt.savefig(filename + ".pdf")


def ex1_c():
    os.makedirs("img", exist_ok=True)

    # Konvergenzplot für `f1`.
    I1ex = np.arctan(np.sqrt(5.0)) / np.sqrt(5.0)
    title = r"Quadraturfehler fuer $f_1(x) = \frac{1}{1 + 5x^2}$"
    convergence_experiment(f1, I1ex, title, "img/convergence_f1")

    # Konvergenzplot für `f2`.
    I2ex = 2.0 / 3.0
    title = r"Quadraturfehler fuer $f_2(x) = \sqrt{x}$"
    convergence_experiment(f2, I2ex, title, "img/convergence_f2")


    # TODO vervollständigen Sie das Template.


if __name__ == "__main__":
    ex1_c()
    plt.show()
